Index: LMDZ6/branches/contrails/libf/dyn3d_common/infotrac.f90
===================================================================
--- LMDZ6/branches/contrails/libf/dyn3d_common/infotrac.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/dyn3d_common/infotrac.f90	(revision 5609)
@@ -266,6 +266,12 @@
    !---------------------------------------------------------------------------------------------------------------------------
    nqtrue = SIZE(tracers)                                                                               !--- "true" tracers
-   nqo    =      COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%name)     == 'H2O')     !--- Water phases
-   nbtr = nqtrue-COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%gen0Name) == 'H2O')     !--- Passed to phytrac
+!   nqo    =      COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%name)     == 'H2O')     !--- Water phases
+   nqo    =      COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%name)     == 'H2O') .OR. &    !--- Water phases
+        (delPhase(tracers(:)%name)     == 'CLDFRA')))
+!   nbtr = nqtrue-COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%gen0Name) == 'H2O')     !--- Passed to phytrac
+   nbtr = nqtrue-COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%gen0Name)     == 'H2O') .OR. &    !--- Passed to phytrac
+        (delPhase(tracers(:)%gen0Name)     == 'CLDFRA')))
    nqCO2  =      COUNT( [type_trac == 'inco', type_trac == 'co2i'] )
 IF (CPPKEY_INCA) THEN
@@ -335,5 +341,7 @@
       t1%iadv       = iad
       t1%isAdvected = iad >= 0
-      t1%isInPhysics= delPhase(t1%gen0Name) /= 'H2O' .OR. t1%component /= 'lmdz' !=== MORE EXCEPTIONS ? CO2i, SURSAT CLOUD H2O
+!      t1%isInPhysics= delPhase(t1%gen0Name) /= 'H2O' .OR. t1%component /= 'lmdz' !=== MORE EXCEPTIONS ? CO2i, SURSAT CLOUD H2O
+      t1%isInPhysics=((delPhase(t1%gen0Name) /= 'H2O') .AND. &
+                      (delPhase(t1%gen0Name) /= 'CLDFRA')) .OR. t1%component /= 'lmdz'
       ttr(iq)       = t1
 
@@ -388,7 +396,13 @@
 
    !--- Note: nqtottr can differ from nbtr when nmom/=0
-   nqtottr = nqtot - COUNT(delPhase(tracers%gen0Name) == 'H2O' .AND. tracers%component == 'lmdz')
-   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
-      CALL abort_gcm(modname, 'problem with the computation of nqtottr', 1)
+!   nqtottr = nqtot - COUNT(delPhase(tracers%gen0Name) == 'H2O' .AND. tracers%component == 'lmdz')
+   nqtottr = nqtot - COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%gen0Name)     == 'H2O') .OR. & 
+        (delPhase(tracers(:)%gen0Name)     == 'CLDFRA')))
+!   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
+!   IF(COUNT(tracers%iso_iName == 0) - COUNT(tracers(:)%component == 'lmdz' .AND. &
+!       ((delPhase(tracers(:)%name)     == 'H2O') .OR. &
+!        (delPhase(tracers(:)%name)     == 'CLDFRA') /= nqtottr) &
+!      CALL abort_gcm(modname, 'problem with the computation of nqtottr', 1)
 
    !=== DISPLAY THE RESULTS
Index: LMDZ6/branches/contrails/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.f90
===================================================================
--- LMDZ6/branches/contrails/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.f90	(revision 5609)
@@ -44,5 +44,5 @@
           solsw, solswfdiff, radsol, t_ancien, wake_deltat, wake_s,  rain_fall, qsol, z0h, &
           sollw,sollwdown, rugoro, q_ancien, wake_deltaq, wake_pe, snow_fall, ratqs,w01, &
-    sig1, ftsol, clwcon, fm_therm, wake_Cstar,  pctsrf,  entr_therm,radpas, f0,&
+    sig1, ftsol, cwcon, clwcon, fm_therm, wake_Cstar,  pctsrf,  entr_therm,radpas, f0,&
     zmax0,fevap, rnebcon,falb_dir, falb_dif, wake_fip,    agesno,  detr_therm, pbl_tke,  &
     phys_state_var_init, ql_ancien, qs_ancien, prlw_ancien, prsw_ancien, &
@@ -50,5 +50,5 @@
     ale_bl, ale_bl_trig, alp_bl, &
     ale_wake, ale_bl_stat, AWAKE_S, &
-    cf_ancien, qvc_ancien, cfa_ancien, qta_ancien
+    cf_ancien, qvc_ancien, cfa_ancien, pcf_ancien, qva_ancien, qia_ancien
 
   USE comconst_mod, ONLY: pi, dtvr
@@ -243,6 +243,9 @@
   cf_ancien = 0.
   qvc_ancien = 0.
+  cwcon = 0.
   cfa_ancien = 0.
-  qta_ancien = 0.
+  pcf_ancien = 0.
+  qva_ancien = 0.
+  qia_ancien = 0.
   
   z0m(:,:)=0 ! ym missing 5th subsurface initialization
Index: LMDZ6/branches/contrails/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/branches/contrails/libf/misc/readTracFiles_mod.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/misc/readTracFiles_mod.f90	(revision 5609)
@@ -63,5 +63,5 @@
     LOGICAL               :: isAdvected  = .FALSE.              !--- "true" tracers: iadv > 0.   COUNT(isAdvected )=nqtrue
     LOGICAL               :: isInPhysics = .TRUE.               !--- "true" tracers: in tr_seri. COUNT(isInPhysics)=nqtottr
-    INTEGER               :: iso_iGroup  = 0                    !--- Isotopes group index in isotopes(:)
+    INTEGER               :: iso_iGroup  = -1                   !--- Isotopes group index in isotopes(:)
     INTEGER               :: iso_iName   = 0                    !--- Isotope  name  index in isotopes(iso_iGroup)%trac(:)
     INTEGER               :: iso_iZone   = 0                    !--- Isotope  zone  index in isotopes(iso_iGroup)%zone(:)
@@ -122,9 +122,9 @@
   !--- SOME PARAMETERS THAT ARE NOT LIKELY TO CHANGE OFTEN
   CHARACTER(LEN=maxlen), SAVE      :: tran0        = 'air'      !--- Default transporting fluid
-  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlibfcaq'    !--- Old phases for water (no separator)
-  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsbfcaq'    !--- Known phases initials
+  CHARACTER(LEN=maxlen), PARAMETER :: old_phases   = 'vlib'     !--- Old phases for water (no separator)
+  CHARACTER(LEN=maxlen), PARAMETER :: known_phases = 'glsb'     !--- Known phases initials
   INTEGER, PARAMETER :: nphases = LEN_TRIM(known_phases)        !--- Number of phases
   CHARACTER(LEN=maxlen), SAVE      :: phases_names(nphases) &   !--- Known phases names
-                                = ['gaseous  ', 'liquid   ', 'solid    ','blownSnow', 'fracCloud', 'cldVapor ', 'aviContra', 'qtContra ']
+                                = ['gaseous  ', 'liquid   ', 'solid    ','blownSnow']
   CHARACTER(LEN=1),      SAVE :: phases_sep  =  '_'             !--- Phase separator
   CHARACTER(LEN=maxlen), SAVE :: isoFile = 'isotopes_params.def'!--- Name of the isotopes parameters file
Index: LMDZ6/branches/contrails/libf/phylmd/create_etat0_unstruct_mod.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/create_etat0_unstruct_mod.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/create_etat0_unstruct_mod.f90	(revision 5609)
@@ -260,4 +260,5 @@
     cf_ancien = 0.
     qvc_ancien = 0.
+    cwcon = 0.
 
     wake_delta_pbl_TKE(:,:,:)=0
Index: LMDZ6/branches/contrails/libf/phylmd/dyn1d/old_lmdz1d.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/dyn1d/old_lmdz1d.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/dyn1d/old_lmdz1d.f90	(revision 5609)
@@ -10,5 +10,5 @@
       USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar,getin
    USE phys_state_var_mod, ONLY : phys_state_var_init, phys_state_var_end, &
-       clwcon, detr_therm, &
+       cwcon, clwcon, detr_therm, &
        qsol, fevap, z0m, z0h, agesno, &
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
@@ -23,5 +23,5 @@
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, &
        ql_ancien, qs_ancien, qbs_ancien, &
-       cf_ancien, qvc_ancien, cfa_ancien, qta_ancien, &
+       cf_ancien, qvc_ancien, cfa_ancien, pcf_ancien, qva_ancien, qia_ancien, &
        prlw_ancien, prsw_ancien, prbsw_ancien, prw_ancien, &
        u10m,v10m,ale_wake,ale_bl_stat
@@ -874,8 +874,11 @@
           cf_ancien = 0.
           qvc_ancien = 0.
+          cwcon = 0.
         ENDIF
         IF ( ok_plane_contrail ) THEN
           cfa_ancien = 0.
-          qta_ancien = 0.
+          pcf_ancien = 0.
+          qva_ancien = 0.
+          qia_ancien = 0.
         ENDIF
 !jyg<
Index: LMDZ6/branches/contrails/libf/phylmd/dyn1d/scm.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/dyn1d/scm.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/dyn1d/scm.f90	(revision 5609)
@@ -6,5 +6,5 @@
    USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar,getin
    USE phys_state_var_mod, ONLY : phys_state_var_init, phys_state_var_end, &
-       clwcon, detr_therm, &
+       cwcon, clwcon, detr_therm, &
        qsol, fevap, z0m, z0h, agesno, &
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
@@ -19,5 +19,5 @@
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, &
        ql_ancien, qs_ancien, qbs_ancien, &
-       cf_ancien, qvc_ancien, cfa_ancien, qta_ancien, &
+       cf_ancien, qvc_ancien, cfa_ancien, pcf_ancien, qva_ancien, qia_ancien, &
        prlw_ancien, prsw_ancien, prbsw_ancien, prw_ancien, &
        u10m,v10m,ale_wake,ale_bl_stat, ratqs_inter_
@@ -616,8 +616,11 @@
           cf_ancien = 0.
           qvc_ancien = 0.
+          cwcon = 0.
         ENDIF
         IF ( ok_plane_contrail ) THEN
           cfa_ancien = 0.
-          qta_ancien = 0.
+          pcf_ancien = 0.
+          qva_ancien = 0.
+          qia_ancien = 0.
         ENDIF
         rain_fall=0.
@@ -820,4 +823,7 @@
       ENDIF
       
+      ! calculation of potential temperature for the advection
+      teta=temp*(pzero/play)**rkappa
+
       ! vertical tendencies computed as d X / d t = -W  d X / d z
 
@@ -829,5 +835,5 @@
         d_v_vert_adv(l)=-w_adv(l)*(v(l+1)-v(l-1))/(z_adv(l+1)-z_adv(l-1))
         ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
-        d_t_vert_adv(l)=-w_adv(l)*(temp(l+1)-temp(l-1))/(z_adv(l+1)-z_adv(l-1)) 
+        d_t_vert_adv(l)=-w_adv(l)*(teta(l+1)-teta(l-1))/(z_adv(l+1)-z_adv(l-1)) / (pzero/play(l))**rkappa
         d_q_vert_adv(l,:)=-w_adv(l)*(q(l+1,:)-q(l-1,:))/(z_adv(l+1)-z_adv(l-1))
       enddo
@@ -842,10 +848,12 @@
           d_u_vert_adv(l)=-w_adv(l)*(u(l)-u(l-1))/(z_adv(l)-z_adv(l-1))
           d_v_vert_adv(l)=-w_adv(l)*(v(l)-v(l-1))/(z_adv(l)-z_adv(l-1))
-          d_t_vert_adv(l)=-w_adv(l)*(temp(l)-temp(l-1))/(z_adv(l)-z_adv(l-1))
+          ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
+          d_t_vert_adv(l)=-w_adv(l)*(teta(l)-teta(l-1))/(z_adv(l)-z_adv(l-1)) / (pzero/play(l))**rkappa
           d_q_vert_adv(l,:)=-w_adv(l)*(q(l,:)-q(l-1,:))/(z_adv(l)-z_adv(l-1))
         ELSE
           d_u_vert_adv(l)=-w_adv(l)*(u(l+1)-u(l))/(z_adv(l+1)-z_adv(l))
           d_v_vert_adv(l)=-w_adv(l)*(v(l+1)-v(l))/(z_adv(l+1)-z_adv(l))
-          d_t_vert_adv(l)=-w_adv(l)*(temp(l+1)-temp(l))/(z_adv(l+1)-z_adv(l))
+          ! d theta / dt = -W d theta / d z, transformed into d temp / d t dividing by (pzero/play(l))**rkappa
+          d_t_vert_adv(l)=-w_adv(l)*(teta(l+1)-teta(l))/(z_adv(l+1)-z_adv(l)) / (pzero/play(l))**rkappa
           d_q_vert_adv(l,:)=-w_adv(l)*(q(l+1,:)-q(l,:))/(z_adv(l+1)-z_adv(l))
         ENDIF
Index: LMDZ6/branches/contrails/libf/phylmd/infotrac_phy.F90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/infotrac_phy.F90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/infotrac_phy.F90	(revision 5609)
@@ -293,6 +293,10 @@
    !---------------------------------------------------------------------------------------------------------------------------
    nqtrue = SIZE(tracers)                                                                               !--- "true" tracers
-   nqo    =      COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%name)     == 'H2O')     !--- Water phases
-   nbtr = nqtrue-COUNT(tracers(:)%component == 'lmdz' .AND. delPhase(tracers(:)%gen0Name) == 'H2O')     !--- Passed to phytrac
+   nqo    =      COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%name)     == 'H2O') .OR. &    !--- Water phases
+        (delPhase(tracers(:)%name)     == 'CLDFRA')))
+   nbtr = nqtrue-COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%gen0Name)     == 'H2O') .OR. &    !--- Passed to phytrac
+        (delPhase(tracers(:)%gen0Name)     == 'CLDFRA')))
    nqCO2  =      COUNT( [type_trac == 'inco', type_trac == 'co2i'] )
 IF (CPPKEY_INCA) THEN
@@ -350,5 +354,7 @@
       t1%longName   = t1%name; IF(iad > 0) t1%longName=TRIM(t1%name)//descrq(iad)
       t1%isAdvected = iad >= 0
-      t1%isInPhysics= delPhase(t1%gen0Name) /= 'H2O' .OR. t1%component /= 'lmdz' !=== MORE EXCEPTIONS ? CO2i, SURSAT CLOUD H2O
+      !t1%isInPhysics= delPhase(t1%gen0Name) /= 'H2O' .OR. t1%component /= 'lmdz' !=== MORE EXCEPTIONS ? CO2i, SURSAT CLOUD H2O
+      t1%isInPhysics=((delPhase(t1%gen0Name) /= 'H2O') .AND. &
+                      (delPhase(t1%gen0Name) /= 'CLDFRA')) .OR. t1%component /= 'lmdz'
       ttr(iq)       = t1
 
@@ -397,7 +403,13 @@
 
    !--- Note: nqtottr can differ from nbtr when nmom/=0
-   nqtottr = nqtot - COUNT(delPhase(tracers%gen0Name) == 'H2O' .AND. tracers%component == 'lmdz')
-   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
-      CALL abort_physic(modname, 'problem with the computation of nqtottr', 1)
+!   nqtottr = nqtot - COUNT(delPhase(tracers%gen0Name) == 'H2O' .AND. tracers%component == 'lmdz')
+   nqtottr = nqtot - COUNT(tracers(:)%component == 'lmdz' .AND. &
+       ((delPhase(tracers(:)%gen0Name)     == 'H2O') .OR. &
+        (delPhase(tracers(:)%gen0Name)     == 'CLDFRA')))
+!   IF(COUNT(tracers%iso_iName == 0) - COUNT(delPhase(tracers%name) == 'H2O' .AND. tracers%component == 'lmdz') /= nqtottr) &
+!   IF(COUNT(tracers%iso_iName == 0) - COUNT(tracers(:)%component == 'lmdz' .AND. &
+!       ((delPhase(tracers(:)%name)     == 'H2O') .OR. &
+!        (delPhase(tracers(:)%name)     == 'CLDFRA'))) /= nqtottr) &
+!      CALL abort_physic(modname, 'problem with the computation of nqtottr', 1)
 
    !=== DISPLAY THE RESULTS
Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_aviation.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_aviation.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_aviation.f90	(revision 5609)
@@ -73,5 +73,5 @@
 SUBROUTINE contrails_formation( &
       klon, dtime, pplay, temp, qsat, qsatl, gamma_cond, flight_dist, &
-      clrfra, pdf_loc, pdf_scale, pdf_alpha, keepgoing, &
+      clrfra, qclr, pdf_scale, pdf_alpha, pdf_gamma, keepgoing, pt_pron_clds, &
       Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
       dcfa_ini, dqia_ini, dqta_ini)
@@ -97,8 +97,10 @@
 REAL,     INTENT(IN) , DIMENSION(klon) :: flight_dist  ! aviation distance flown concentration [m/s/m3]
 REAL,     INTENT(IN) , DIMENSION(klon) :: clrfra       ! clear sky fraction [-]
-REAL,     INTENT(IN) , DIMENSION(klon) :: pdf_loc      ! location parameter of the clear sky PDF [%]
+REAL,     INTENT(IN) , DIMENSION(klon) :: qclr         ! clear sky specific humidity [kg/kg]
 REAL,     INTENT(IN) , DIMENSION(klon) :: pdf_scale    ! scale parameter of the clear sky PDF [%]
 REAL,     INTENT(IN) , DIMENSION(klon) :: pdf_alpha    ! shape parameter of the clear sky PDF [-]
+REAL,     INTENT(IN) , DIMENSION(klon) :: pdf_gamma    ! tmp parameter of the clear sky PDF [-]
 LOGICAL,  INTENT(IN) , DIMENSION(klon) :: keepgoing    ! .TRUE. if a new condensation loop should be computed
+LOGICAL,  INTENT(IN) , DIMENSION(klon) :: pt_pron_clds  ! .TRUE. if clouds are prognostic in this mesh
 !
 ! Output
@@ -119,7 +121,8 @@
 REAL, DIMENSION(klon) :: qsatl_crit, dqsatl_crit
 REAL :: Gcont, psatl_crit, pcrit
-REAL :: pdf_x, pdf_y, pdf_e2, pdf_e3
-REAL :: pdf_fra_above_qcritcont, pdf_fra_above_qsat, pdf_fra_above_qnuc
-REAL :: pdf_q_above_qcritcont, pdf_q_above_qsat, pdf_q_above_qnuc
+REAL :: rhl_clr, pdf_loc
+REAL :: pdf_x, pdf_y, pdf_e3
+REAL :: pdf_fra_above_qcritcont, pdf_fra_above_qsat
+REAL :: pdf_q_above_qcritcont, pdf_q_above_qsat
 REAL :: qpotcontP
 !
@@ -159,5 +162,5 @@
 
 DO i = 1, klon
-  IF ( keepgoing(i) .AND. ( temp(i) .LE. temp_nowater ) ) THEN
+  IF ( keepgoing(i) .AND. pt_pron_clds(i) .AND. ( temp(i) .LE. temp_nowater ) ) THEN
     
     psatl_crit = qsatl_crit(i) / ( EPS_W + ( 1. - EPS_W ) * qsatl_crit(i) ) * pplay(i)
@@ -168,36 +171,25 @@
     IF ( ( clrfra(i) .GT. eps ) .AND. ( temp(i) .LT. Tcritcont(i) ) ) THEN
     
+      rhl_clr = qclr(i) / clrfra(i) / qsatl(i) * 100.
+      pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
       pdf_x = qcritcont(i) / qsatl(i) * 100.
-      pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-      pdf_e2 = GAMMA(1. + 1. / pdf_alpha(i))
+      pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
       pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-      pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
+      pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
       pdf_fra_above_qcritcont = EXP( - pdf_y ) * clrfra(i)
       pdf_q_above_qcritcont = ( pdf_e3 * clrfra(i) &
-          + pdf_loc(i) * pdf_fra_above_qcritcont ) * qsatl(i) / 100.
-    
-      pdf_x = gamma_cond(i) * qsat(i) / qsatl(i) * 100.
-      pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-      pdf_e2 = GAMMA(1. + 1. / pdf_alpha(i))
+          + pdf_loc * pdf_fra_above_qcritcont ) * qsatl(i) / 100.
+    
+      pdf_x = qsat(i) / qsatl(i) * 100.
+      pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
       pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-      pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
-      pdf_fra_above_qnuc = EXP( - pdf_y ) * clrfra(i)
-      pdf_q_above_qnuc = ( pdf_e3 * clrfra(i) &
-          + pdf_loc(i) * pdf_fra_above_qnuc ) * qsatl(i) / 100.
-    
-      pdf_x = qsat(i) / qsatl(i) * 100.
-      pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-      pdf_e2 = GAMMA(1. + 1. / pdf_alpha(i))
-      pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-      pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
+      pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
       pdf_fra_above_qsat = EXP( - pdf_y ) * clrfra(i)
       pdf_q_above_qsat = ( pdf_e3 * clrfra(i) &
-          + pdf_loc(i) * pdf_fra_above_qsat ) * qsatl(i) / 100.
+          + pdf_loc * pdf_fra_above_qsat ) * qsatl(i) / 100.
     
       potcontfraNP(i) = MAX(0., pdf_fra_above_qcritcont - pdf_fra_above_qsat)
-      potcontfraP(i) = MAX(0., MIN(pdf_fra_above_qsat - pdf_fra_above_qnuc, &
-                        pdf_fra_above_qcritcont - pdf_fra_above_qnuc))
-      qpotcontP = MAX(0., MIN(pdf_q_above_qsat - pdf_q_above_qnuc, &
-                      pdf_q_above_qcritcont - pdf_q_above_qnuc))
+      potcontfraP(i) = MIN(pdf_fra_above_qsat, pdf_fra_above_qcritcont)
+      qpotcontP = MIN(pdf_q_above_qsat, pdf_q_above_qcritcont)
 
     ENDIF ! temp .LT. Tcritcont
@@ -219,129 +211,10 @@
 
 !**********************************************************************************
-FUNCTION QVAPINCLD_DEPSUB_CONTRAILS( &
-    qvapincld, qiceincld, temp, qsat, pplay, dtime)
-
-USE lmdz_lscp_ini,        ONLY: RV, RLSTT, RTT, EPS_W
-USE lmdz_lscp_ini,        ONLY: depo_coef_cirrus, capa_cond_cirrus, rho_ice
-USE lmdz_lscp_ini,        ONLY: rm_ice_crystals_contrails
+FUNCTION contrail_cross_section_onera()
+
+USE lmdz_lscp_ini, ONLY: initial_width_contrails, initial_height_contrails
 
 IMPLICIT NONE
 
-! inputs
-REAL :: qvapincld     ! 
-REAL :: qiceincld     ! 
-REAL :: temp          ! 
-REAL :: qsat          ! 
-REAL :: pplay         ! 
-REAL :: dtime         ! time step [s]
-! output
-REAL :: qvapincld_depsub_contrails
-! local
-REAL :: pres_sat, rho, kappa
-REAL :: air_thermal_conduct, water_vapor_diff
-REAL :: rm_ice
-
-!--If ok_unadjusted_clouds is set to TRUE, then the saturation adjustment
-!--hypothesis is lost, and the vapor in the cloud is purely prognostic.
-!
-!--The deposition equation is
-!-- dmi/dt = alpha*4pi*C*Svi / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) )
-!--from Lohmann et al. (2016), where
-!--alpha is the deposition coefficient [-]
-!--mi is the mass of one ice crystal [kg]
-!--C is the capacitance of an ice crystal [m]
-!--Svi is the supersaturation ratio equal to (qvc - qsat)/qsat [-]
-!--R_v is the specific gas constant for humid air [J/kg/K]
-!--T is the temperature [K]
-!--esi is the saturation pressure w.r.t. ice [Pa]
-!--Dv is the diffusivity of water vapor [m2/s]
-!--Ls is the specific latent heat of sublimation [J/kg/K]
-!--ka is the thermal conductivity of dry air [J/m/s/K]
-!
-!--alpha is a coefficient to take into account the fact that during deposition, a water
-!--molecule cannot join the crystal from everywhere, it must do so that the crystal stays
-!--coherent (with the same structure). It has no impact for sublimation.
-!--We fix alpha = depo_coef_cirrus (=0.5 by default following Lohmann et al. (2016))
-!--during deposition, and alpha = 1. during sublimation.
-!--The capacitance of the ice crystals is proportional to a parameter capa_cond_cirrus
-!-- C = capa_cond_cirrus * rm_ice
-!
-!--We have qice = Nice * mi, where Nice is the ice crystal
-!--number concentration per kg of moist air
-!--HYPOTHESIS 1: the ice crystals are spherical, therefore
-!-- mi = 4/3 * pi * rm_ice**3 * rho_ice
-!--HYPOTHESIS 2: the ice crystals are monodisperse with the
-!--initial radius rm_ice_0.
-!--NB. this is notably different than the assumption
-!--of a distributed qice in the cloud made in the sublimation process;
-!--should it be consistent?
-!
-!--As the deposition process does not create new ice crystals,
-!--and because we assume a same rm_ice value for all crystals
-!--therefore the sublimation process does not destroy ice crystals
-!--(or, in a limit case, it destroys all ice crystals), then
-!--Nice is a constant during the sublimation/deposition process.
-!-- dmi = dqi, et Nice = qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
-!
-!--The deposition equation then reads:
-!-- dqi/dt = alpha*4pi*capa_cond_cirrus*rm_ice*(qvc-qsat)/qsat / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) ) * Nice
-!-- dqi/dt = alpha*4pi*capa_cond_cirrus* (qi / qi_0)**(1/3) *rm_ice_0*(qvc-qsat)/qsat &
-!--             / ( R_v*T/esi/Dv + Ls/ka/T * (Ls*R_v/T - 1) ) &
-!--                         * qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
-!-- dqi/dt = qi**(1/3) * (qvc - qsat) * qi_0**(2/3) &
-!--  *alpha/qsat*capa_cond_cirrus/ (R_v*T/esi/Dv + Ls/ka/T*(Ls*R_v/T - 1)) / ( 1/3 rm_ice_0**2 rho_ice )
-!--and we have
-!-- dqvc/dt = - qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
-!-- dqi/dt  =   qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
-!--where kappa = 1/3*rho_ice/capa_cond_cirrus*qsat*(R_v*T/esi/Dv + Ls/ka/T*(Ls/R_v/T - 1))
-!
-!--This system of equations can be resolved with an exact
-!--explicit numerical integration, having one variable resolved
-!--explicitly, the other exactly. The exactly resolved variable is
-!--the one decreasing, so it is qvc if the process is
-!--condensation, qi if it is sublimation.
-!
-!--kappa is computed as an initialisation constant, as it depends only
-!--on temperature and other pre-computed values
-pres_sat = qsat / ( EPS_W + ( 1. - EPS_W ) * qsat ) * pplay
-!--This formula for air thermal conductivity comes from Beard and Pruppacher (1971)
-air_thermal_conduct = ( 5.69 + 0.017 * ( temp - RTT ) ) * 1.e-3 * 4.184
-!--This formula for water vapor diffusivity comes from Hall and Pruppacher (1976)
-water_vapor_diff = 0.211 * ( temp / RTT )**1.94 * ( 101325. / pplay ) * 1.e-4
-kappa = 1. / 3. * rho_ice / capa_cond_cirrus * qsat &
-      * ( RV * temp / water_vapor_diff / pres_sat &
-        + RLSTT / air_thermal_conduct / temp * ( RLSTT / RV / temp - 1. ) )
-!--NB. the greater kappa, the lower the efficiency of the deposition/sublimation process
-
-!--Here, the initial vapor in the cloud is qvapincld, and we compute
-!--the new vapor qvapincld_depsub_contrails
-
-rm_ice = rm_ice_crystals_contrails
-
-IF ( qvapincld .GE. qsat ) THEN
-  !--If the cloud is initially supersaturated
-  !--Exact explicit integration (qvc exact, qice explicit)
-  qvapincld_depsub_contrails = qsat + ( qvapincld - qsat ) &
-                * EXP( - depo_coef_cirrus * dtime * qiceincld / kappa / rm_ice**2 )
-ELSE
-  !--If the cloud is initially subsaturated
-  !--Exact explicit integration (qvc exact, qice explicit)
-  !--Same but depo_coef_cirrus = 1
-  qvapincld_depsub_contrails = qsat + ( qvapincld - qsat ) &
-                * EXP( - dtime * qiceincld / kappa / rm_ice**2 )
-  IF ( qvapincld_depsub_contrails .GE. ( qvapincld + qiceincld ) ) &
-                qvapincld_depsub_contrails = 0.
-ENDIF ! qvapincld .GT. qsat
-
-END FUNCTION QVAPINCLD_DEPSUB_CONTRAILS
-
-
-!**********************************************************************************
-FUNCTION contrail_cross_section_onera()
-
-USE lmdz_lscp_ini, ONLY: initial_width_contrails, initial_height_contrails
-
-IMPLICIT NONE
-
 !
 ! Output
@@ -355,4 +228,5 @@
 
 END FUNCTION contrail_cross_section_onera
+
 
 SUBROUTINE read_aviation_emissions(klon, klev)
Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_call_cloud_optics_prop.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_call_cloud_optics_prop.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_call_cloud_optics_prop.f90	(revision 5609)
@@ -12,6 +12,6 @@
     icefrac_optics, dNovrN, ptconv,rnebcon, ccwcon, &
     !--AB contrails
-    contfra, qice_cont, pclc_nocont, pcltau_nocont, pclemi_nocont, &
-    pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
+    contfra, perscontfra, qice_cont, qice_perscont, pclc_nocont, &
+    pcltau_nocont, pclemi_nocont, pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
     xfiwp_nocont, xfiwc_nocont, reice_nocont)
 
@@ -95,6 +95,8 @@
 
   !--AB for contrails. All these are used / outputed only if ok_plane_contrail=y
-  REAL, INTENT(IN)  :: contfra(klon, klev)       ! contrails fraction [-]
-  REAL, INTENT(IN)  :: qice_cont(klon, klev)     ! contrails condensed water [kg/kg]
+  REAL, INTENT(IN)  :: contfra(klon, klev)       ! linear contrails fraction [-]
+  REAL, INTENT(IN)  :: perscontfra(klon, klev)   ! contrail induced cirrus fraction [-]
+  REAL, INTENT(IN)  :: qice_cont(klon, klev)     ! linear contrails condensed water [kg/kg]
+  REAL, INTENT(IN)  :: qice_perscont(klon, klev) ! contrail induced cirrus condensed water [kg/kg]
   REAL, INTENT(OUT) :: pch_nocont(klon)          ! 2D high cloud cover without contrails[-]
   REAL, INTENT(OUT) :: pct_cont(klon)            ! 2D total contrails cover[-]
@@ -137,6 +139,6 @@
     icefrac_optics, dNovrN, ptconv,rnebcon, ccwcon, &
     !--AB for contrails
-    contfra, qice_cont, pclc_nocont, pcltau_nocont, pclemi_nocont, &
-    pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
+    contfra, perscontfra, qice_cont, qice_perscont, pclc_nocont, pcltau_nocont, &
+    pclemi_nocont, pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
     xfiwp_nocont, xfiwc_nocont, reice_nocont)
   ELSE
